import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type {
  ProductTabs,
  ProductTabsParam
} from '@/api/oa/product/tabs/model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询产品属性
 */
export async function pageProductTabs(params: ProductTabsParam) {
  const res = await request.get<ApiResult<PageResult<ProductTabs>>>(
    MODULES_API_URL + '/oa/product-tabs/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询产品属性列表
 */
export async function listProductTabs(params?: ProductTabsParam) {
  const res = await request.get<ApiResult<ProductTabs[]>>(
    MODULES_API_URL + '/oa/product-tabs',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询产品属性
 */
export async function getProductTabs(id: number) {
  const res = await request.get<ApiResult<ProductTabs>>(
    MODULES_API_URL + '/oa/product-tabs/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加产品属性
 */
export async function addProductTabs(data: ProductTabs) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/product-tabs',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改产品属性
 */
export async function updateProductTabs(data: ProductTabs) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/product-tabs',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除产品属性
 */
export async function removeProductTabs(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/product-tabs/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除产品属性
 */
export async function removeBatchProductTabs(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/product-tabs/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 检查IP是否存在
 */
export async function checkExistence(
  field: string,
  value: string,
  id?: number
) {
  const res = await request.get<ApiResult<unknown>>(
    MODULES_API_URL + '/oa/product-tabs/existence',
    {
      params: { field, value, id }
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
